=== debian/changelog ===
highway (1.0.7-7) unstable; urgency=medium

  * d/rules: Do not build EMU128 code
  * d/patches: Really fix ppc10/htm issue

 -- Mathieu Malaterre <malat@debian.org>  Fri, 15 Sep 2023 11:47:57 +0200

highway (1.0.7-6) unstable; urgency=medium

  * d/patches: workaround for inlining error on ppc64el
  * d/rules: Run armhf/neon test suite

 -- Mathieu Malaterre <malat@debian.org>  Thu, 14 Sep 2023 14:45:34 +0200

highway (1.0.7-5) unstable; urgency=medium

  * d/patches: Workaround for ppc64el/lto
  * d/rules: Run math_test on i386 cpus

 -- Mathieu Malaterre <malat@debian.org>  Thu, 14 Sep 2023 08:26:21 +0200

highway (1.0.7-4) unstable; urgency=medium

  * d/patches: Workaround to current RVV/GCC-13 limitation
  * d/patches: Remove extra ppc64el patch not needed

 -- Mathieu Malaterre <malat@debian.org>  Wed, 13 Sep 2023 08:43:20 +0200

highway (1.0.7-3) unstable; urgency=medium

  * d/patches: fix compilation with LTO
  * d/rules: Workaround for loong64 and old GCC 12.x
  * d/rules: Start building with LTO
  * d/rules: Start building highway with g++-13 on most arches
  * d/control: Add explicit highway keyword. Closes: #1051450

 -- Mathieu Malaterre <malat@debian.org>  Tue, 12 Sep 2023 08:45:41 +0200

highway (1.0.7-2) unstable; urgency=medium

  * d/patches: Fix make test on i386
  * d/rules: Prefer g++-12 for now. See #1050933

 -- Mathieu Malaterre <malat@debian.org>  Thu, 31 Aug 2023 16:20:57 +0200

highway (1.0.7-1) unstable; urgency=medium

  * New upstream version 1.0.7
  * d/patches: Fixes for float16_t/bfloat16_t operator++ and operator--
  * d/rules: Fix armhf neon-less system. Closes: #1033656

 -- Mathieu Malaterre <malat@debian.org>  Thu, 31 Aug 2023 12:09:44 +0200

highway (1.0.6-1) unstable; urgency=medium

  * d/install: Run wrap-and-sort
  * New upstream version 1.0.6

 -- Mathieu Malaterre <malat@debian.org>  Sat, 26 Aug 2023 14:00:06 +0200

highway (1.0.5-1) unstable; urgency=medium

  * New upstream version 1.0.5
  * d/symbols: Add missing symbols

 -- Mathieu Malaterre <malat@debian.org>  Wed, 23 Aug 2023 11:39:21 +0200

highway (1.0.4-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable)

  [ Mathieu Malaterre ]
  * New upstream version 1.0.4
  * d/patches: Remove patches applied upstream

 -- Mathieu Malaterre <malat@debian.org>  Tue, 22 Aug 2023 13:11:58 +0200
