=== debian/changelog ===
highway (1.1.0-3) unstable; urgency=medium

  * d/rules: Use PDF 1.5
  * d/rules: Really fix armhf buildd
  * d/rules: Fix compilation on i386

 -- Mathieu Malaterre <malat@debian.org>  Wed, 29 May 2024 19:10:36 +0200

highway (1.1.0-2) unstable; urgency=medium

  * d/symbols: Fix lintian error
  * d/patches: Allow AVX2 on x86
  * d/rules: Reduce optimization on armhf
  * d/patches: Fix compilation on Hurd

 -- Mathieu Malaterre <malat@debian.org>  Wed, 29 May 2024 08:52:30 +0200

highway (1.1.0-1) unstable; urgency=medium

  * d/rules: loong64 has switched to GCC-13
  * New upstream version 1.1.0
  * d/symbols: Add new symbol
  * d/patches: Refresh patches

 -- Mathieu Malaterre <malat@debian.org>  Fri, 24 May 2024 13:22:20 +0200

highway (1.0.7-8.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062340

 -- Lukas Märdian <slyon@debian.org>  Wed, 28 Feb 2024 10:28:57 +0000

highway (1.0.7-8) unstable; urgency=medium

  * d/rules: Remove gcc-12 workaround
  * d/patches: Fix bug on aarch64+emu128
  * d/rules: Prefer EMU128 over SCALAR

 -- Mathieu Malaterre <malat@debian.org>  Fri, 06 Oct 2023 09:30:48 +0200
