=== debian/rules ===
--- 
+++ 
@@ -9,29 +9,30 @@
 %:
 	dh $@ --buildsystem=cmake+ninja
 
-# Remove EMU128 for now
-# https://gcc.gnu.org/bugzilla/show_bug.cgi?id=111231
 # Let's pretend to know what we are doing:
-#DEB_CXXFLAGS_MAINT_APPEND += -DHWY_BROKEN_EMU128=0
+DEB_CXXFLAGS_MAINT_APPEND += -DHWY_BROKEN_EMU128=0
 
 ifneq (,$(filter $(DEB_HOST_ARCH), armel armhf))
   # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=77728
   DEB_CXXFLAGS_MAINT_APPEND += -Wno-psabi
 endif
 
-ifneq (,$(filter $(DEB_HOST_ARCH), loong64))
-  # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=106322
-  DEB_CXXFLAGS_MAINT_APPEND += -fno-tree-vectorize
-endif
-
 ifeq ($(DEB_HOST_ARCH_CPU),i386)
   # https://github.com/google/highway/issues/1488
   DEB_CXXFLAGS_MAINT_APPEND += -fexcess-precision=standard
+  # https://github.com/google/highway/issues/2208
+  DEB_CXXFLAGS_MAINT_APPEND += --param ggc-min-expand=10
 endif
 
 ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),armhf))
   # https://github.com/google/highway/issues/1271
   CMAKE_EXTRA_FLAGS += -DHWY_CMAKE_ARM7:BOOL=ON
+  # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=111231
+  DEB_CXXFLAGS_MAINT_APPEND += -fno-tree-vectorize
+  # https://github.com/google/highway/issues/2200
+  DEB_CXXFLAGS_MAINT_APPEND += -O1
+  # Switching to O1 generate a different error than O2, prefer O0:
+  DEB_CXXFLAGS_MAINT_APPEND += -O0
 endif
 
 ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),riscv64))
@@ -40,13 +41,6 @@
 endif
 
 include /usr/share/dpkg/buildtools.mk
-
-ifneq (,$(filter $(DEB_HOST_ARCH), arm64 armhf))
-  CC=gcc-12
-  CXX=g++-12
-  export CC
-  export CXX
-endif
 
 export DEB_CXXFLAGS_MAINT_APPEND
 
@@ -91,7 +85,7 @@
 	# let's shrink a bit this one:
 	gs  -q -dNOPAUSE -dBATCH -dSAFER \
 		-sDEVICE=pdfwrite \
-		-dCompatibilityLevel=1.4 \
+		-dCompatibilityLevel=1.5 \
 		-dPDFSETTINGS=/screen \
 		-dEmbedAllFonts=true \
 		-dSubsetFonts=true \
