## highway 1.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,7 @@
 # Copyright 2019 Google LLC
+# Copyright 2024 Arm Limited and/or its affiliates <open-source-office@arm.com>
+# SPDX-License-Identifier: Apache-2.0
+# SPDX-License-Identifier: BSD-3-Clause
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
@@ -33,7 +36,7 @@
   cmake_policy(SET CMP0128 NEW)
 endif()
 
-project(hwy VERSION 1.1.0)  # Keep in sync with highway.h version
+project(hwy VERSION 1.2.0)  # Keep in sync with base.h version
 # `hwy` is lowercase to handle find_package() in Config mode:
 set(namespace "${PROJECT_NAME}::")
 
@@ -76,10 +79,35 @@
 # arise due to compiler/platform changes. Enable this in CI/tests.
 set(HWY_WARNINGS_ARE_ERRORS OFF CACHE BOOL "Add -Werror flag?")
 
+# Experimental support for header-only builds
+set(HWY_CMAKE_HEADER_ONLY OFF CACHE BOOL "Change to header-only?")
+
 set(HWY_ENABLE_CONTRIB ON CACHE BOOL "Include contrib/")
 set(HWY_ENABLE_EXAMPLES ON CACHE BOOL "Build examples")
 set(HWY_ENABLE_INSTALL ON CACHE BOOL "Install library")
 set(HWY_ENABLE_TESTS ON CACHE BOOL "Enable HWY tests")
+
+if (NOT DEFINED CMAKE_CXX_STANDARD)
+  if ("cxx_std_17" IN_LIST CMAKE_CXX_COMPILE_FEATURES)
+    set(HWY_CXX_STD_TGT_COMPILE_FEATURE cxx_std_17)
+  else()
+    if ("cxx_std_14" IN_LIST CMAKE_CXX_COMPILE_FEATURES)
+      set(HWY_CXX_STD_TGT_COMPILE_FEATURE cxx_std_14)
+    else()
+      set(HWY_CXX_STD_TGT_COMPILE_FEATURE cxx_std_11)
+    endif()
+  endif()
+else()
+  if (CMAKE_CXX_STANDARD GREATER_EQUAL 14 AND CMAKE_CXX_STANDARD LESS 98)
+    if (CMAKE_CXX_STANDARD GREATER_EQUAL 17)
+      set(HWY_CXX_STD_TGT_COMPILE_FEATURE cxx_std_17)
+    else()
+      set(HWY_CXX_STD_TGT_COMPILE_FEATURE cxx_std_14)
+    endif()
+  else()
+    set(HWY_CXX_STD_TGT_COMPILE_FEATURE cxx_std_11)
+  endif()
+endif()
 
 include(CheckCXXSourceCompiles)
 check_cxx_source_compiles(
@@ -107,11 +135,13 @@
 # additional special cases.
 file(GLOB HWY_CONTRIB_SOURCES "hwy/contrib/sort/vqsort_*.cc")
 list(APPEND HWY_CONTRIB_SOURCES
+    hwy/contrib/bit_pack/bit_pack-inl.h
     hwy/contrib/dot/dot-inl.h
     hwy/contrib/image/image.cc
     hwy/contrib/image/image.h
     hwy/contrib/math/math-inl.h
     hwy/contrib/matvec/matvec-inl.h
+    hwy/contrib/random/random-inl.h
     hwy/contrib/sort/order.h
     hwy/contrib/sort/shared-inl.h
     hwy/contrib/sort/sorting_networks-inl.h
@@ -122,6 +152,8 @@
     hwy/contrib/sort/vqsort.h
     hwy/contrib/thread_pool/futex.h
     hwy/contrib/thread_pool/thread_pool.h
+    hwy/contrib/thread_pool/topology.cc
+    hwy/contrib/thread_pool/topology.h
     hwy/contrib/algo/copy-inl.h
     hwy/contrib/algo/find-inl.h
     hwy/contrib/algo/transform-inl.h
@@ -130,44 +162,51 @@
 endif()  # HWY_ENABLE_CONTRIB
 
 set(HWY_SOURCES
-    hwy/aligned_allocator.cc
+    hwy/abort.h
     hwy/aligned_allocator.h
     hwy/base.h
     hwy/cache_control.h
     hwy/detect_compiler_arch.h  # private
     hwy/detect_targets.h  # private
     hwy/foreach_target.h
+    hwy/highway_export.h
     hwy/highway.h
-    hwy/highway_export.h
-    hwy/nanobenchmark.cc
     hwy/nanobenchmark.h
-    hwy/profiler.h
     hwy/ops/arm_neon-inl.h
     hwy/ops/arm_sve-inl.h
     hwy/ops/emu128-inl.h
     hwy/ops/generic_ops-inl.h
+    hwy/ops/inside-inl.h
     hwy/ops/ppc_vsx-inl.h
     hwy/ops/rvv-inl.h
     hwy/ops/scalar-inl.h
     hwy/ops/set_macros-inl.h
     hwy/ops/shared-inl.h
     hwy/ops/wasm_128-inl.h
-    hwy/ops/tuple-inl.h
     hwy/ops/x86_128-inl.h
     hwy/ops/x86_256-inl.h
     hwy/ops/x86_512-inl.h
-    hwy/per_target.cc
     hwy/per_target.h
     hwy/print-inl.h
+    hwy/print.h
+    hwy/profiler.h
+    hwy/robust_statistics.h
+    hwy/targets.h
+    hwy/timer-inl.h
+    hwy/timer.h
+)
+
+if (NOT HWY_CMAKE_HEADER_ONLY)
+  list(APPEND HWY_SOURCES
+    hwy/abort.cc
+    hwy/aligned_allocator.cc
+    hwy/nanobenchmark.cc
+    hwy/per_target.cc
     hwy/print.cc
-    hwy/print.h
-    hwy/robust_statistics.h
     hwy/targets.cc
-    hwy/targets.h
     hwy/timer.cc
-    hwy/timer.h
-    hwy/timer-inl.h
-)
+  )
+endif()
 
 set(HWY_TEST_SOURCES
     hwy/tests/hwy_gtest.h
@@ -180,7 +219,52 @@
   set(HWY_FLAGS
     # fix build error C1128 in blockwise*_test & arithmetic_test
     /bigobj
+
+    # Warnings
+    /W4
+    # Disable some W4 warnings.  Enable them individually after they are cleaned up.
+    /wd4100
+    /wd4127
+    /wd4324
+    /wd4456
+    /wd4701
+    /wd4702
+    /wd4723
+
+    # CMake automatically adds exception handling flags.  Remove them.
+    /GR-
+    /EHs-c-
+    # Disable exceptions in STL code.
+    -D_HAS_EXCEPTIONS=0
   )
+
+  # This adds extra warnings for the clang-cl compiler on Windows.
+  # This is the same as the sections in the else part.
+  # These could be refactored.
+  if (${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
+    list(APPEND HWY_FLAGS
+      # These are not included in Wall nor Wextra:
+      -Wconversion
+      -Wsign-conversion
+      -Wvla
+      -Wnon-virtual-dtor
+
+      -Wfloat-overflow-conversion
+      -Wfloat-zero-conversion
+      -Wfor-loop-analysis
+      -Wgnu-redeclared-enum
+      -Winfinite-recursion
+      -Wself-assign
+      -Wstring-conversion
+      -Wtautological-overlap-compare
+      -Wthread-safety-analysis
+      -Wundefined-func-template
+    )
+  endif()
+
+  if (HWY_WARNINGS_ARE_ERRORS)
+    list(APPEND HWY_FLAGS /WX)
+  endif()
 else()
   set(HWY_FLAGS
     # Avoid changing binaries based on the current time and date.
@@ -200,6 +284,7 @@
     -Wsign-conversion
     -Wvla
     -Wnon-virtual-dtor
+    -Wcast-align # see -Wcast-align=strict on x86
   )
 
   if(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
@@ -312,6 +397,10 @@
 
 endif()  # !MSVC
 
+if (HWY_CMAKE_HEADER_ONLY)
+  list(APPEND HWY_FLAGS -DHWY_HEADER_ONLY)
+endif()
+
 include(CheckIncludeFile)
 check_include_file(sys/auxv.h  HAVE_SYS_AUXV_H)
 check_include_file(asm/hwcap.h HAVE_ASM_HWCAP_H)
@@ -328,56 +417,3 @@
 
 # Copy-cat "add_library" logic + add override.
 set(HWY_LIBRARY_TYPE "SHARED")
-if (NOT BUILD_SHARED_LIBS OR HWY_FORCE_STATIC_LIBS)
-  set(HWY_LIBRARY_TYPE "STATIC")
-endif()
-
-# This preprocessor define will drive the build, also used in the *.pc files:
-if("${HWY_LIBRARY_TYPE}" STREQUAL "SHARED")
-  set(DLLEXPORT_TO_DEFINE "HWY_SHARED_DEFINE")
-else()
-  set(DLLEXPORT_TO_DEFINE "HWY_STATIC_DEFINE")
-endif()
-
-add_library(hwy ${HWY_LIBRARY_TYPE} ${HWY_SOURCES})
-if(NOT HAVE_SYS_AUXV_H)
-  target_compile_definitions(hwy PUBLIC TOOLCHAIN_MISS_SYS_AUXV_H)
-endif()
-if(NOT HAVE_ASM_HWCAP_H)
-  target_compile_definitions(hwy PUBLIC TOOLCHAIN_MISS_ASM_HWCAP_H)
-endif()
-target_compile_definitions(hwy PUBLIC "${DLLEXPORT_TO_DEFINE}")
-target_compile_options(hwy PRIVATE ${HWY_FLAGS})
-set_property(TARGET hwy PROPERTY POSITION_INDEPENDENT_CODE ON)
-set_target_properties(hwy PROPERTIES VERSION ${LIBRARY_VERSION} SOVERSION ${LIBRARY_SOVERSION})
-target_include_directories(hwy PUBLIC
-    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}>
-    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
-target_compile_features(hwy PUBLIC cxx_std_11)
-set_target_properties(hwy PROPERTIES
-  LINK_DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/hwy/hwy.version)
-# For GCC __atomic_store_8, see #887
-target_link_libraries(hwy PRIVATE ${ATOMICS_LIBRARIES})
-# not supported by MSVC/Clang, safe to skip (we use DLLEXPORT annotations)
-if(UNIX AND NOT APPLE)
-  set_property(TARGET hwy APPEND_STRING PROPERTY
-    LINK_FLAGS " -Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/hwy/hwy.version")
-endif()
-
-if (HWY_ENABLE_CONTRIB)
-add_library(hwy_contrib ${HWY_LIBRARY_TYPE} ${HWY_CONTRIB_SOURCES})
-target_link_libraries(hwy_contrib PUBLIC hwy)
-target_compile_options(hwy_contrib PRIVATE ${HWY_FLAGS})
-set_property(TARGET hwy_contrib PROPERTY POSITION_INDEPENDENT_CODE ON)
-set_target_properties(hwy_contrib PROPERTIES VERSION ${LIBRARY_VERSION} SOVERSION ${LIBRARY_SOVERSION})
-target_include_directories(hwy_contrib PUBLIC
-    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}>
-    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
-target_compile_features(hwy_contrib PUBLIC cxx_std_11)
-set_target_properties(hwy_contrib PROPERTIES
-  LINK_DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/hwy/hwy.version)
-# For GCC __atomic_store_8, see #887
-target_link_libraries(hwy_contrib PRIVATE ${ATOMICS_LIBRARIES})
-# not supported by MSVC/Clang, safe to skip (we use DLLEXPORT annotations)
-if(UNIX AND NOT APPLE)
-  set_property(TARGET hwy_contrib APPEND_STRING PROPERTY
