=== debian/changelog ===
highway (1.2.0-5) unstable; urgency=medium

  * d/rules: Use g++-14 on riscv64 for now

 -- Mathieu Malaterre <malat@debian.org>  Sun, 09 Nov 2025 17:44:55 +0100

highway (1.2.0-4) unstable; urgency=medium

  [ Simon Chopin ]
  * Cherry-pick an upstream patch to fix GCC15 build for ppc64el (LP: #2124959)
  * Force use of GCC 14 on ppc64el to work around codegen issue (LP: #2121375)
  * Disable LTO on riscv64 to work around GCC15 build issue (LP: #2121375)

 -- Mathieu Malaterre <malat@debian.org>  Thu, 06 Nov 2025 22:08:53 +0100

highway (1.2.0-3) unstable; urgency=medium

  [ Jeremy Bícha ]
  * Use Build-Depends-Package
  * Bump debhelper compat to 13
  * Drop obsolete Pre-Depends

  [ Nathan Pratta Teodosio ]
  * Add autopkgtest. (Closes: #1076436)

 -- Mathieu Malaterre <malat@debian.org>  Wed, 05 Nov 2025 15:03:39 +0100

highway (1.2.0-2) unstable; urgency=medium

  * d/patches: Import upstream fix to fix failing test
  * d/patches: Fix building on riscv64
  * d/rules: Re-allow default i386 flags

 -- Mathieu Malaterre <malat@debian.org>  Mon, 10 Jun 2024 17:52:26 +0200

highway (1.2.0-1) unstable; urgency=medium

  [ Mathieu Malaterre ]
  * New upstream version 1.2.0
  * d/patches: Refresh patches for new release
  * d/symbols: Update symbol file

  [ Stephen Kitt ]
  * d/lintian: Fix package-name-doesnt-match-sonames

 -- Mathieu Malaterre <malat@debian.org>  Mon, 10 Jun 2024 13:16:09 +0200
