=== debian/rules ===
--- 
+++ 
@@ -20,8 +20,6 @@
 ifeq ($(DEB_HOST_ARCH_CPU),i386)
   # https://github.com/google/highway/issues/1488
   DEB_CXXFLAGS_MAINT_APPEND += -fexcess-precision=standard
-  # https://github.com/google/highway/issues/2208
-  DEB_CXXFLAGS_MAINT_APPEND += --param ggc-min-expand=10
 endif
 
 ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),armhf))
@@ -38,6 +36,20 @@
 ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),riscv64))
   # https://github.com/google/highway/issues/1740
   CMAKE_EXTRA_FLAGS += -DHWY_CMAKE_RVV:BOOL=OFF
+  # LP: #2121375
+  export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
+endif
+
+ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),ppc64el))
+  # See https://github.com/google/highway/issues/2743
+  export CC=gcc-14
+  export CXX=g++-14
+endif
+
+ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),riscv64))
+  # See https://github.com/google/highway/issues/2793
+  export CC=gcc-14
+  export CXX=g++-14
 endif
 
 include /usr/share/dpkg/buildtools.mk
