=== debian/tests/control ===
Tests: compile-and-execute
Depends: g++, libhwy-dev, pkgconf
Restrictions: allow-stderr
