## highway 1.2.1~git20240610.f384204

=== debian/changelog ===
highway (1.2.1~git20240610.f384204-4) experimental; urgency=medium

  * d/patches: Split mul_test to allow compilation on x32
  * d/rules: Fix compilation on arm64 (no sve)

 -- Mathieu Malaterre <malat@debian.org>  Tue, 25 Jun 2024 10:54:13 +0200

highway (1.2.1~git20240610.f384204-3) experimental; urgency=medium

  * d/rules: Fix arm64 build (GCC PR/109753)
  * d/patches: Fix compilation on x32

 -- Mathieu Malaterre <malat@debian.org>  Fri, 21 Jun 2024 12:32:10 +0200

highway (1.2.1~git20240610.f384204-2) experimental; urgency=medium

  * d/patches: Do not use AES gcc option on armhf
  * d/rules: Fix compilation options on s390x

 -- Mathieu Malaterre <malat@debian.org>  Tue, 11 Jun 2024 13:55:21 +0200

highway (1.2.1~git20240610.f384204-1) experimental; urgency=medium

  * d/watch: Bump to latest version
  * New upstream version 1.2.1~git20240610.f384204
  * d/changelog: Sync from master
  * d/patches: Refresh patches

 -- Mathieu Malaterre <malat@debian.org>  Tue, 11 Jun 2024 08:32:23 +0200
