=== debian/control ===
--- 
+++ 
@@ -3,10 +3,8 @@
 Priority: optional
 Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
 Uploaders: Mathieu Malaterre <malat@debian.org>
-Build-Depends: cmake,
-               debhelper-compat (= 13),
-               dpkg-dev (>= 1.22.5),
-               g++-14 [ppc64el riscv64],
+Build-Depends: cmake (>= 3.13),
+               debhelper (>= 11),
                libgtest-dev,
                ninja-build
 Build-Depends-Indep: ghostscript
@@ -21,6 +19,7 @@
 Replaces: libhwy1
 Breaks: libhwy1 (<< ${source:Version})
 Architecture: any
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Multi-Arch: same
 Description: Efficient and performance-portable SIMD wrapper (runtime files)
@@ -34,6 +33,7 @@
 Package: libhwy-dev
 Architecture: any
 Section: libdevel
+Pre-Depends: ${misc:Pre-Depends}
 Depends: libhwy1t64 (= ${binary:Version}), ${misc:Depends}
 Multi-Arch: same
 Description: Efficient and performance-portable SIMD wrapper (developer files)
