=== debian/rules ===
--- 
+++ 
@@ -15,41 +15,43 @@
 ifneq (,$(filter $(DEB_HOST_ARCH), armel armhf))
   # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=77728
   DEB_CXXFLAGS_MAINT_APPEND += -Wno-psabi
+  # Disable unaligned access
+  DEB_CXXFLAGS_MAINT_APPEND += -mno-unaligned-access
 endif
 
-ifeq ($(DEB_HOST_ARCH_CPU),i386)
-  # https://github.com/google/highway/issues/1488
-  DEB_CXXFLAGS_MAINT_APPEND += -fexcess-precision=standard
+ifneq (,$(filter $(DEB_HOST_ARCH), arm64))
+  # Disable unaligned access
+  DEB_CXXFLAGS_MAINT_APPEND += -mstrict-align
+  # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=109753
+  DEB_CXXFLAGS_MAINT_APPEND += -march=armv8-a
+endif
+
+ifneq (,$(filter $(DEB_HOST_ARCH), loong64))
+  # Disable unaligned access
+  DEB_CXXFLAGS_MAINT_APPEND += -mstrict-align
+endif
+
+ifneq (,$(filter $(DEB_HOST_ARCH), powerpc ppc64))
+  DEB_CXXFLAGS_MAINT_APPEND += -maltivec -mcpu=power8
+  # Disable unaligned access
+  DEB_CXXFLAGS_MAINT_APPEND += -mstrict-align
+endif
+
+ifneq (,$(filter $(DEB_HOST_ARCH), s390x))
+  # To compile for Z14 or later, use the -march=z14 -mzvector compiler options.
+  DEB_CXXFLAGS_MAINT_APPEND += -march=z14 -mzvector
 endif
 
 ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),armhf))
   # https://github.com/google/highway/issues/1271
   CMAKE_EXTRA_FLAGS += -DHWY_CMAKE_ARM7:BOOL=ON
-  # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=111231
-  DEB_CXXFLAGS_MAINT_APPEND += -fno-tree-vectorize
-  # https://github.com/google/highway/issues/2200
-  DEB_CXXFLAGS_MAINT_APPEND += -O1
-  # Switching to O1 generate a different error than O2, prefer O0:
-  DEB_CXXFLAGS_MAINT_APPEND += -O0
 endif
 
 ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),riscv64))
   # https://github.com/google/highway/issues/1740
   CMAKE_EXTRA_FLAGS += -DHWY_CMAKE_RVV:BOOL=OFF
-  # LP: #2121375
-  export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
-endif
-
-ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),ppc64el))
-  # See https://github.com/google/highway/issues/2743
-  export CC=gcc-14
-  export CXX=g++-14
-endif
-
-ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),riscv64))
-  # See https://github.com/google/highway/issues/2793
-  export CC=gcc-14
-  export CXX=g++-14
+  # Disable unaligned access
+  DEB_CXXFLAGS_MAINT_APPEND += -mstrict-align
 endif
 
 include /usr/share/dpkg/buildtools.mk
@@ -58,10 +60,11 @@
 
 # test suite rely on CMAKE_SKIP_RPATH=OFF
 CMAKE_EXTRA_FLAGS += \
+ -DBUILD_SHARED_LIBS:BOOL=ON \
+ -DCMAKE_BUILD_TYPE:STRING=Release \
  -DCMAKE_SKIP_RPATH:BOOL=OFF \
- -DBUILD_SHARED_LIBS:BOOL=ON \
+ -DHWY_SYSTEM_GTEST:BOOL=ON \
  -DHWY_WARNINGS_ARE_ERRORS:BOOL=ON \
- -DHWY_SYSTEM_GTEST:BOOL=ON
 
 ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 CMAKE_EXTRA_FLAGS += -DBUILD_TESTING=OFF
@@ -69,12 +72,6 @@
 
 override_dh_auto_configure-arch:
 	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)
-
-override_dh_auto_install-arch:
-ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),armhf))
-	sed -i -e 's/HWY_CMAKE_ARM7:BOOL=ON/HWY_CMAKE_ARM7:BOOL=OFF/' obj-*/CMakeCache.txt
-endif
-	dh_auto_install
 
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 # run default example to check compilation ok:
