## highway 1.3.0

=== debian/changelog ===
highway (1.3.0-1) unstable; urgency=medium

  * New upstream version 1.3.0
  * d/patches: Remove patches applied upstream
  * d/control: Bump Std-Vers no changes needed

 -- Mathieu Malaterre <malat@debian.org>  Wed, 03 Dec 2025 07:42:27 +0100
