=== debian/control ===
--- 
+++ 
@@ -3,12 +3,14 @@
 Priority: optional
 Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
 Uploaders: Mathieu Malaterre <malat@debian.org>
-Build-Depends: cmake (>= 3.13),
-               debhelper (>= 11),
+Build-Depends: cmake,
+               debhelper-compat (= 13),
+               dpkg-dev (>= 1.22.5),
+               g++-14 [ppc64el riscv64],
                libgtest-dev,
                ninja-build
 Build-Depends-Indep: ghostscript
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://github.com/google/highway
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/highway.git
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/highway
@@ -19,7 +21,6 @@
 Replaces: libhwy1
 Breaks: libhwy1 (<< ${source:Version})
 Architecture: any
-Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Multi-Arch: same
 Description: Efficient and performance-portable SIMD wrapper (runtime files)
@@ -33,7 +34,6 @@
 Package: libhwy-dev
 Architecture: any
 Section: libdevel
-Pre-Depends: ${misc:Pre-Depends}
 Depends: libhwy1t64 (= ${binary:Version}), ${misc:Depends}
 Multi-Arch: same
 Description: Efficient and performance-portable SIMD wrapper (developer files)
